//
// BotMixer5000 - botman's multibot loader
//
// (http://planethalflife.com/botman/)
//
// bot_mixer.h
//

#ifndef BOT_MIXER_H
#define BOT_MIXER_H

// stuff for Win32 vs. Linux builds

#ifndef __linux__

#define BotLibrary HINSTANCE
typedef int (FAR *GETENTITYAPI)(DLL_FUNCTIONS *, int);
typedef int (FAR *GETNEWDLLFUNCTIONS)(NEW_DLL_FUNCTIONS *, int *);
typedef void (DLLEXPORT *GIVEFNPTRSTODLL)(enginefuncs_t *, globalvars_t *);
typedef void (FAR *LINK_ENTITY_FUNC)(entvars_t *);

#else

#include <dlfcn.h>
#define GetProcAddress dlsym
#define Sleep sleep

typedef int BOOL;

#define BotLibrary void *
typedef int (*GETENTITYAPI)(DLL_FUNCTIONS *, int);
typedef int (*GETNEWDLLFUNCTIONS)(NEW_DLL_FUNCTIONS *, int *);
typedef void (*GIVEFNPTRSTODLL)(enginefuncs_t *, globalvars_t *);
typedef void (*LINK_ENTITY_FUNC)(entvars_t *);

#endif


#define MAX_DLLS 10

typedef struct {
   char cmd[32];
   char dll_filename[64];
   BotLibrary h_Library;
   GETENTITYAPI other_GetEntityAPI;
   GETNEWDLLFUNCTIONS other_GetNewDLLFunctions;
   GIVEFNPTRSTODLL other_GiveFnptrsToDll;
   DLL_FUNCTIONS other_gFunctionTable;
} bot_dlls_t;

typedef struct {
   edict_t *pEdict;
   int bot_dll_index;
} bot_t;


// define some function prototypes...
BOOL ClientConnect( edict_t *pEntity, const char *pszName,
                    const char *pszAddress, char szRejectReason[ 128 ] );
void ClientPutInServer( edict_t *pEntity );
void ClientCommand( edict_t *pEntity );

void FakeClientCommand(edict_t *pBot, char *arg1, char *arg2, char *arg3);

const char *Cmd_Args( void );
const char *Cmd_Argv( int argc );
int Cmd_Argc( void );

// new util functions...
void UTIL_Pathname_Convert(char *pathname);
void UTIL_TrimWhitespace(char *text);
void UTIL_ReplaceWhitespace(char *text);


#endif // BOT_MIXER_H

