//
// BotMixer5000 - botman's multibot loader
//
// (http://planethalflife.com/botman/)
//
// util.cpp
//

#include "extdll.h"
#include "util.h"
#include "engine.h"

#include "bot_mixer.h"


void UTIL_Pathname_Convert(char *pathname)
{
   int index;
   int len = strlen(pathname);

   for (index=0; index < len; index++)
   {
#ifndef __linux__
      if (pathname[index] == '/')  // convert to MS-DOS format
         pathname[index] = '\\';
#else
      if (pathname[index] == '\\')  // convert to Linux format
         pathname[index] = '/';
#endif
   }
}


void UTIL_TrimWhitespace(char *text)
{
   int len, index;

   len = strlen(text)-1;  // start a last character (one before null)

   // trim off trailing tabs, whitespace or newline...
   while ((len > 0) &&
          (text[len] == ' ') || (text[len] == '\t') ||
          (text[len] == '\n'))
   {
      text[len] = 0;  // trim off trailing blanks, tabs or newline
      len--;
   }

   // trim off leading tabs or whitespace...
   while ((text[0] != 0) &&
          (text[0] == ' ') || (text[0] == '\t'))
   {
      len = strlen(text);  // this will also move the null terminator
      for (index=0; index < len; index++)
         text[index] = text[index+1];
   }
}


void UTIL_ReplaceWhitespace(char *text)
{
   int len, index, index2;

   len = strlen(text);

   index = 0;

   while ((len > 1) && (text[index] != 0))
   {
      if (((text[index] == ' ') || (text[index] == '\t')) &&
          ((text[index+1] == ' ') || (text[index+1] == '\t')))
      {
         // shuffle all the rest of the characters down one position...
         for (index2=index+1; index2 < len; index2++)
            text[index2] = text[index2+1];

         if (text[index] == '\t')
            text[index] = ' ';  // change tabs to spaces

         len--;
      }
      else
      {
         index++;
      }
   }
}
